package de.espirit.firstspirit.opt.example.universal.dataaccess;

import de.espirit.firstspirit.access.BaseContext;
import de.espirit.firstspirit.client.plugin.dataaccess.DataAccessSession;
import de.espirit.firstspirit.client.plugin.dataaccess.DataAccessSessionBuilder;
import de.espirit.firstspirit.client.plugin.dataaccess.aspects.SessionBuilderAspectType;

import org.jetbrains.annotations.NotNull;
import org.jetbrains.annotations.Nullable;


/**
 * This class instantiates a {@link DataAccessSession DataAccessSession<D>} object.
 */
public class TextBlocksDataAccessSessionBuilder implements DataAccessSessionBuilder<TextBlocksObject> {

	/**
	 * Provides the requested aspect object, if available.
	 *
	 * @param type The type of aspect.
	 * @param <A> The requested aspect interface.
	 * @return An implementation of {@code <A>}, or {@code null} if no aspect of that type exists in the aspect map.
	 */
	@Nullable
	@Override
	public <A> A getAspect(@NotNull final SessionBuilderAspectType<A> type) {
		return null;
	}


	/**
	 * Instantiates a {@link TextBlocksDataAccessSession} object which provides data handling functionality around {@link TextBlocksObject}s.
	 *
	 * @param context The session operating context.
	 * @return A {@link DataAccessSession DataAccessSession<D>}.
	 */
	@NotNull
	@Override
	public DataAccessSession<TextBlocksObject> createSession(@NotNull final BaseContext context) {
		return new TextBlocksDataAccessSession(context);
	}
}
