package de.espirit.firstspirit.opt.example.universal.dataaccess.aspects;

import de.espirit.firstspirit.client.plugin.dataaccess.DataAccessSession;
import de.espirit.firstspirit.client.plugin.dataaccess.aspects.JsonSupporting;
import de.espirit.firstspirit.generate.functions.json.JsonGenerationContext;
import de.espirit.firstspirit.json.JsonElement;
import de.espirit.firstspirit.json.JsonObject;
import de.espirit.firstspirit.json.JsonPair;
import de.espirit.firstspirit.json.values.JsonStringValue;
import de.espirit.firstspirit.opt.example.universal.dataaccess.TextBlocksObject;

import org.jetbrains.annotations.NotNull;


/**
 * {@link DataAccessSession DataAccessSession<D>} Aspect: {@link JsonSupporting JsonSupporting<D>}
 */
public class TextBlocksJsonSupportingDataAccessSessionAspect implements JsonSupporting<TextBlocksObject> {


	@NotNull
	@Override
	public JsonElement<?> handle(@NotNull final JsonGenerationContext context, @NotNull final TextBlocksObject value) {
		final JsonObject result = JsonObject.create();
		result.put(JsonPair.of("title", JsonStringValue.of(value.getTitle())));
		result.put(JsonPair.of("text", JsonStringValue.of(value.getText())));
		result.put(JsonPair.of("work", JsonStringValue.of(value.getWork())));
		result.put(JsonPair.of("myIdentifier", JsonStringValue.of(value.getId())));
		return result;
	}


	@NotNull
	@Override
	public Class<TextBlocksObject> getSupportedClass() {
		return TextBlocksObject.class;
	}

}
