package de.espirit.firstspirit.opt.example.universal.gadget;

import de.espirit.firstspirit.ui.gadgets.swing.SwingGadget;
import de.espirit.firstspirit.ui.gadgets.swing.SwingGadgetContext;
import de.espirit.firstspirit.ui.gadgets.swing.SwingGadgetFactory;
import de.espirit.firstspirit.webedit.server.gadgets.WebPluginGadget;

import org.jetbrains.annotations.NotNull;


/**
 * Factory class for the Phone Number input component's web gadget. Instantiates a {@link WebPluginGadget} implementation
 * and associates required CSS and JavaScript files for client-side use.
 */
public class PhoneNumberSwingGadgetFactory implements SwingGadgetFactory<GomPhoneNumber> {

	@NotNull
	@Override
	public SwingGadget create(@NotNull final SwingGadgetContext<GomPhoneNumber> context) {
		return new PhoneNumberSwingGadget(context);
	}
}
