package de.espirit.firstspirit.opt.example.universal.gadget;

import de.espirit.firstspirit.client.access.editor.ValueEngineer;
import de.espirit.firstspirit.client.access.editor.ValueEngineerContext;
import de.espirit.firstspirit.client.access.editor.ValueEngineerFactory;


/**
 * Factory class for the Phone Number input component's value processing facility. Instantiates a {@link ValueEngineer}
 * implementation.
 */
public class PhoneNumberValueEngineerFactory implements ValueEngineerFactory<PhoneNumber, GomPhoneNumber> {

	@Override
	public Class<PhoneNumber> getType() {
		return PhoneNumber.class;
	}


	@Override
	public ValueEngineer<PhoneNumber> create(final ValueEngineerContext<GomPhoneNumber> context) {
		return new PhoneNumberValueEngineer(context);
	}
}
