package de.espirit.firstspirit.opt.example.universal.report;

import de.espirit.firstspirit.client.plugin.report.ReportContext;
import de.espirit.firstspirit.webedit.plugin.report.ClientScriptProvidingReportItem;

import org.jetbrains.annotations.NotNull;
import org.jetbrains.annotations.Nullable;

import java.util.ResourceBundle;


public class TextBlocksClientScriptProvidingReportItem implements ClientScriptProvidingReportItem<TextBlocksObject> {

	private final ResourceBundle _resourceBundle;


	TextBlocksClientScriptProvidingReportItem(@NotNull final ResourceBundle resourceBundle) {
		_resourceBundle = resourceBundle;
	}


	@NotNull
	@Override
	public String getLabel(@NotNull final ReportContext<TextBlocksObject> context) {
		return _resourceBundle.getString("TextBlocksReportItem.script.label");
	}


	@Nullable
	@Override
	public String getIconPath(@NotNull final ReportContext<TextBlocksObject> context) {
		return null;
	}


	@Nullable
	@Override
	public String getScript(final ReportContext<TextBlocksObject> context) {
		final TextBlocksObject reportItem = context.getObject();
		final StringBuilder script = new StringBuilder();
		script.append("var element = document.createElement('div');");
		script.append("element.style.padding = '15px';");
		script.append("element.innerHTML = '")
				.append("<section style=").append('"').append("max-width: 240px;").append('"').append('>')
				.append("<img src=").append('"').append("webclient_examples/media/report/textblocks/").append(reportItem.getImageFileName()).append('"').append(" style=").append('"').append("float: left; max-width: 29px;").append('"').append("/>")
				.append("<h1 style=").append('"').append("margin-left: 49px; margin-top: 0;").append('"').append('>').append(reportItem.getTitle()).append("</h1>")
				.append("<hr style=").append('"').append("border: 1px solid #565557;").append('"').append("/>");
		script.append("<p>");
		if (reportItem.getText() != null && !reportItem.getText().isEmpty()) {
			script.append(reportItem.getText());
		} else {
			script.append(_resourceBundle.getString("TextBlocksReportItem.notext"));
		}
		script.append("</p>");
		script.append("</section>");
		script.append("';");
		script.append("var dialog = top.WE_API.Common.createDialog();");
		script.append("dialog.setContent(element);");
		script.append("dialog.setSize(300, 300);");
		script.append("dialog.setTitle('").append(_resourceBundle.getString("TextBlocksReportPlugin.name")).append("');");
		script.append("dialog.addButton('").append(_resourceBundle.getString("TextBlocksReportItem.close")).append("', function(result){dialog.hide();});");
		script.append("dialog.show();");
		return script.toString();
	}


	@Override
	public boolean isVisible(@NotNull final ReportContext<TextBlocksObject> context) {
		return true;
	}


	@Override
	public boolean isEnabled(@NotNull final ReportContext<TextBlocksObject> context) {
		return true;
	}
}
