package de.espirit.firstspirit.opt.example.universal.report;

import de.espirit.firstspirit.agency.OperationAgent;
import de.espirit.firstspirit.client.plugin.report.JavaClientExecutableReportItem;
import de.espirit.firstspirit.client.plugin.report.ReportContext;
import de.espirit.firstspirit.ui.operations.RequestOperation;
import de.espirit.firstspirit.webedit.plugin.report.WebeditExecutableReportItem;

import org.jetbrains.annotations.NotNull;
import org.jetbrains.annotations.Nullable;

import javax.swing.Icon;
import java.util.ResourceBundle;


public class TextBlocksExecutableReportItem implements JavaClientExecutableReportItem<TextBlocksObject>, WebeditExecutableReportItem<TextBlocksObject> {

	private final ResourceBundle _resourceBundle;


	TextBlocksExecutableReportItem(@NotNull final ResourceBundle resourceBundle) {
		_resourceBundle = resourceBundle;
	}


	@Nullable
	@Override
	public Icon getIcon(@NotNull final ReportContext<TextBlocksObject> context) {
		return null;
	}


	@Nullable
	@Override
	public String getIconPath(@NotNull final ReportContext<TextBlocksObject> context) {
		return null;
	}


	@Override
	public boolean isVisible(@NotNull final ReportContext<TextBlocksObject> context) {
		return true;
	}


	@Override
	public boolean isEnabled(@NotNull final ReportContext<TextBlocksObject> context) {
		return true;
	}


	@NotNull
	@Override
	public String getLabel(@NotNull final ReportContext<TextBlocksObject> context) {
		return _resourceBundle.getString("TextBlocksReportItem.executable.label");
	}


	@Override
	public void execute(@NotNull final ReportContext<TextBlocksObject> context) {
		final TextBlocksObject reportObject = context.getObject();
		final OperationAgent operationAgent = context.requestSpecialist(OperationAgent.TYPE);
		if (operationAgent != null) {
			final RequestOperation requestOperation = operationAgent.getOperation(RequestOperation.TYPE);
			if (requestOperation != null) {
				requestOperation.setKind(RequestOperation.Kind.INFO);
				requestOperation.setTitle(reportObject.getTitle());
				requestOperation.addAnswer(_resourceBundle.getString("TextBlocksReportItem.close"));
				requestOperation.perform(reportObject.getText() != null ? reportObject.getText() : _resourceBundle.getString("TextBlocksReportItem.notext"));
			}
		}
	}
}
